import React, { Component } from 'react';
import {Sensor,Data} from './model.js' 
import { Link } from 'react-router-dom';
import mqtt from 'mqtt';
import {BrowserRouter as Router,Route, Redirect} from 'react-router-dom'
import './App.css';


/////////////////////////////////////////////////////////////////////////////////////////////////

/*** La classe Composants afin d'afficher les capteurs avec leurs noms et leurs valeurs***/
class Composants extends React.Component
{
	
	
	render(){

		console.log(this.props.capteur);
		if ( typeof(this.props.capteur) === 'undefined' ){
			return (
				<div>
					<p> Loading || Capteur inexistant </p>
				</div>
			);
		}
         //avoir les dernières valeurs du capteur
        let dernieres_vals = this.props.capteur.data.values.slice(Math.max(this.props.capteur.data.values.length - 6, 1))
        
        console.log(dernieres_vals);

        //réccuperer les valeurs
        const values = dernieres_vals.map(function(v)
        {
            if (Number(v)){
                return  <tr><td>{Number(v).toFixed(3)} °C</td></tr>
            }else{
                return  <tr><td>{v} </td></tr>
            }
    
        });
         

    ////réccuperer la tout derniére valeur

        var Last_val;
	
		if (Number(this.props.capteur.data.getlastValues())){
			Last_val = parseFloat(this.props.capteur.data.getlastValues()).toFixed(3);
		}else{
			Last_val = this.props.capteur.data.getlastValues();
		}	
    
        ////affichage des valeurs et de la dernière valeur du sensor
				return (
			<div>
					<h1> {this.props.capteur.name+ "   " + "Type:"+this.props.capteur.type+""}</h1>
					<div>
						<div>
							<h2>Valeurs en cours: </h2>
							<p>{Last_val} °C </p>
							
						</div>
					</div>
                    <div>
                  <table>{values}</table>
      
  
                    </div>  
			</div>
			
		);
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/***La classe Sensors est pour afficher tous les sensors.****/

class Sensors extends React.Component{
  render(){
      
      const values = this.props.list.map(function(v){
          return <li>
                      <Link to={`/${v.name}`}>
                          <button> 
                              {v.name}
                          </button>
                      </Link>
                      
                  </li>
      });
      return (
          <ul>{values}</ul>
      );
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// connexion au serveur mqtt
var user_mqtt = mqtt.connect('mqtt://127.0.0.1:8081')


user_mqtt.on('connect', function () {
    user_mqtt.subscribe('#')
})

// déclarer une Liste de sensors  
let liste_S= [];

// fonction permettant de reccperer les sensors sous forme d'une liste
function Liste_Sensors(name, list){
 var i;
  for (i = 0; i < list.length; i++) {
      if (list[i].name === name) {
          return list[i];
      }
  }
}

class App extends Component {
  constructor(props) {

    super(props); 
    this.sensor = null;
    this.state = {value: '',list: []};
    this.handleChange = this.handleChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.rendom_app_sensor();
  }

  handleChange(event) {
    this.setState({value: "/"+event.target.value});
  }
  
  handleSubmit(event) {
    return <Redirect to="" />;    
  }
  //réccuperer les capteurs de random sensor
   rendom_app_sensor(){
    let Liste_resultat = this;
    user_mqtt.on('message', function (topic, message) { 
               
        var Json = JSON.parse(message.toString());//// lire les messages du json
        // Lire le sensore (nom,valeur et type)
        var name_sen = topic.substring(6);
        var val_sen = Json['value'];        
        var type_Sen = Json['type'] 
      
        var donnees = new Data([val_sen]);// l'instance data du model
        var Sen= new Sensor(name_sen,type_Sen,donnees);//l'instance sensor  
                  
          liste_S.push(Sen);// insérer le sensor dans la liste précedente
              
          Sen=Liste_Sensors(name_sen,liste_S);
     
          Array.prototype.push.apply(Sen.data.values, [val_sen]);//inserer les valueurs dans un tableau 
                
          Liste_resultat.setState({list:liste_S});
      });
  }


  // retourner le state des sensors sous forme d'une liste 
  State(name)
  {
    
    var i;
    for (i = 0; i < this.state.list.length; i++)
     {
        if (this.state.list[i].name === name) {
            return this.state.list[i];
        }
    }
  }
//afficher et structurer mes componenents 

  render() {
    return (
        //ajouter les routes
      <Router>

      <div>

        
          <header><center>
            <form onSubmit={this.handleSubmit} action={this.state.value}> 
                Broker :
                <input type="text" onChange={this.handleChange}/>
                <input type="submit" value="ENTREE" />
            </form> 
            </center>
          </header>
          
          <div className="wrapper">
            <nav>
                <Sensors list={this.state.list}/>
            </nav>

            <article>
              <Route path="/:nameSensor" render={(props) => {return <Composants capteur={this.State(props.match.params.nameSensor)} /> }} />
            </article>
            
          </div>
          <footer>

          </footer>
        
       </div>
       </Router>
       
    );
  }
 
}

export default App;
